import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.sql.*;
import java.text.DateFormat;

public class uudised extends HttpServlet{
	static final String HEADER="<html><head><title>Uudised</title><link href=\"../stiil.css\" rel=\"stylesheet\"></head><body>";
    static final String FOOTER="</body></html>";
 	boolean logitud=false;

   public void doGet(HttpServletRequest request, HttpServletResponse response) throws IOException, ServletException{
 	 response.setContentType("text/html");
 	 PrintWriter output=response.getWriter();
	 
     HttpSession session = request.getSession(true);
	 Boolean tmpLog=(Boolean)session.getAttribute("logitud");
	 if (tmpLog!=null){
		 logitud=tmpLog.booleanValue();
	 }

	int type=0;
	if (request.getParameter("type")!=null){
		type=Integer.parseInt(request.getParameter("type"));
		if (type<0){
			type=0;
		}		
	}

	 int msg_per_page=5;
	 if(request.getParameter("limit")!=null){
		msg_per_page=Integer.parseInt(request.getParameter("limit"));
		if (msg_per_page>100 || msg_per_page<0){
			msg_per_page=10;
		}
	}

	 int start=0;
	 if(request.getParameter("start")!=null){
		start=Integer.parseInt(request.getParameter("start"));
		if (start<0){
			start=0;
		}
	}

	output.println(HEADER);

	try{
	 Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
     Connection connection=DriverManager.getConnection("jdbc:odbc:uudised","","");
   	 Statement statement=connection.createStatement();	
	 PreparedStatement ps;
	 ResultSet rs;

	if (type==0){
	 	 rs=statement.executeQuery("select count(*) as kokku from messages ");
	 }else{
	     ps=connection.prepareStatement("select count(*) as kokku from messages where type=?");
	     ps.setInt(1, type);
		 rs=ps.executeQuery();
	}

	 rs.next();
	 int kokku=rs.getInt("kokku");	

	 output.println("<h1>Uudised</h1>");
	if (type>0){
	 	output.println("Valitud grupis on kokku "+kokku+(kokku==1?" uudis!": " uudist!")+" Kikide gruppide ngemiseks vajutage <a href=\"uudised\">SIIA!</a>");
	}else{
	    output.println("Kokku "+kokku+(kokku==1?" uudis ": " uudist "));
	}


	output.println("<hr><a href=\"logimine\">Logi "+(logitud?"vlja":"sisse")+"</a>");
	if(logitud){
		output.println(" | <a href=\"uudisteForm\">Lisa uudis</a>");
	}
	output.println(" | <a href=\"uudisedXML\"> Kmme viimast uudist koos kommentaaridega XML's</a><hr><br>");
	if (kokku>5){
	 output.println("<form action=\"uudised\" method=\"get\">"+
		"Nitan <select name=\"limit\">"+
		"<option value=\"5\" "+(msg_per_page==5?" selected=true ":"")+">5</option>"+
		"<option value=\"10\" "+(msg_per_page==10?" selected=true ":"")+">10</option>"+
		"<option value=\"15\" "+(msg_per_page==15?" selected=true ":"")+">15</option>"+
		"<option value=\"20\" "+(msg_per_page==20?" selected=true ":"")+">20</option>"+
		"<option value=\"30\" "+(msg_per_page==30?" selected=true ":"")+">30</option>"+
		"<option value=\"50\" "+(msg_per_page==50?" selected=true ":"")+">50</option>"+
		"</select> kaupa. "+
		"<input type=\"hidden\" name=\"type\" value=\""+type+"\">"+
		"<input type=\"submit\" value=\"Tee seda\"></form>");
	}

	if (kokku>msg_per_page){
		output.println("| ");
	 	for(int i=0; i<kokku; i+=msg_per_page){
			if (start>=i && start<i+msg_per_page){
				output.println(""+(i+1)+"-"+(((i+msg_per_page)<kokku?(i+msg_per_page):kokku))+" | ");
			}else{
				output.println("<a href=\"uudised?start="+i+"&limit="+msg_per_page+"\">"+(i+1)+"-"+(((i+msg_per_page)<kokku?(i+msg_per_page):kokku))+"</a> | ");
			}
		}	 
	}	

	if (type>0){
	     ps=connection.prepareStatement("select *, count(msgid) as kommentaare from messages left join comments on messages.id=comments.msgid left join types on messages.type=types.typeid where type=? group by id order by id desc limit ?, ?");
	  	 ps.setInt(1, type);
 		 ps.setInt(2, start);
		 ps.setInt(3, msg_per_page);
		 rs=ps.executeQuery();
	}else{
	     ps=connection.prepareStatement("select *, count(msgid) as kommentaare from messages left join comments on messages.id=comments.msgid left join types on messages.type=types.typeid group by id order by id desc limit ?, ?");
 		 ps.setInt(1, start);
		 ps.setInt(2, msg_per_page);
		 rs=ps.executeQuery();
	}
     Date aeg;
	 String strAeg;

	  while(rs.next()){
			aeg=rs.getDate("time");
			if (aeg!=null){
			 	DateFormat df = DateFormat.getDateInstance(DateFormat.FULL);
				strAeg=df.format(aeg);
			} else{
				strAeg=" (aeg puudub)";
			}
		int id=rs.getInt("id");
		int typeid=rs.getInt("typeid");
        output.println("<table width=\"600\"><tr><th colspan=\"2\">"+rs.getString("header")+"</th></tr><tr><td aling=\"left\"> Kirjutas: "+rs.getString("msgauthor")+" @ "+strAeg+"</td><td align=\"right\"><a href=\"uudised?type="+typeid+"&limit="+msg_per_page+"\">Tp: "+rs.getString("name")+"</a></td>"+
          "<tr bgcolor=\"#eeeeee\"><td colspan=\"2\">"+rs.getString("contents")+"</td></tr>"+
		 "<tr><td>"+(logitud?("<a href=\"uudisteForm?id="+id+"&type="+typeid+"\">Muuda</a> | <a href=\"kustutaja?id="+id+"\">Kustuta</a>"):"&nbsp;")+"</td><td align=\"right\"><a href=\"uudisteKom?id="+id+"\">Kommentaare: "+rs.getInt("kommentaare")+"</a></td></tr></table><br>");
        }
    output.println("</table>");
    connection.close();
	}catch(Exception e ){
		output.println("<h1>VIGA</h1>"+e.getMessage());
	}
	output.println(FOOTER);
   }



}