import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.sql.*;
import java.text.DateFormat;

public class uudisteKom extends HttpServlet{
	static final String HEADER="<html><head><title>Uudised</title><link href=\"../stiil.css\" rel=\"stylesheet\"></head><body>";
    static final String FOOTER="</body></html>";
	boolean logitud=false;

   public void doGet(HttpServletRequest request, HttpServletResponse response) throws IOException, ServletException{
     Date aeg;
	 String strAeg;
	 DateFormat df = DateFormat.getDateInstance(DateFormat.FULL);

     response.setContentType("text/html");
 	 PrintWriter output=response.getWriter();
	 
     HttpSession session = request.getSession(true);
	 Boolean tmpLog=(Boolean)session.getAttribute("logitud");
	 if (tmpLog!=null){
		 logitud=tmpLog.booleanValue();
	 }

	int msg_per_page=5;
	 if(request.getParameter("limit")!=null){
		msg_per_page=Integer.parseInt(request.getParameter("limit"));
		if (msg_per_page>100 || msg_per_page<0){
			msg_per_page=10;
		}
	}

	 int start=0;
	 if(request.getParameter("start")!=null){
		start=Integer.parseInt(request.getParameter("start"));
		if (start<0){
			start=0;
		}
	}

	 int id=0;
	 if(request.getParameter("id")!=null){
		id=Integer.parseInt(request.getParameter("id"));
		if (id<0){
			 response.sendRedirect("uudised");
		}
	}else{
		response.sendRedirect("uudised");
	}

	try{
	 Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
     Connection connection=DriverManager.getConnection("jdbc:odbc:uudised","","");
     PreparedStatement ps=connection.prepareStatement("select count(*) as kokku from comments where msgid=?");
	 ps.setInt(1, id);

	 ResultSet rs=ps.executeQuery();
	 rs.next();
	 int kokku=rs.getInt("kokku");	

  	 ps=connection.prepareStatement("select * from messages left join types on messages.type=types.typeid where messages.id=?");
   	 ps.setInt(1, id);
	 rs=ps.executeQuery();
	 if (!rs.next()){
		 response.sendRedirect("uudised");	
     }

	aeg=rs.getDate("time");
	if (aeg!=null){
		strAeg=df.format(aeg);
	} else{
			strAeg=" (aeg puudub)";
	}

     output.println(HEADER);
	 output.println("<h1>Kommentaarid</h1>");
	 output.println("Kokku "+kokku+(kokku==1?" kommentaar!":" kommentaari!"));
	output.println("<hr><a href=\"uudised\">Nita uudiseid</a><hr>");
	 output.println("<table width=\"600\"><tr><th colspan=\"2\">"+rs.getString("header")+"</th></tr><tr><td aling=\"left\"> Kirjutas: "+rs.getString("msgauthor")+" @ "+strAeg+"</td><td align=\"right\"><a href=\"uudised?type="+rs.getInt("typeid")+"\">Tp: "+rs.getString("name")+"</a></td>"+
          "<tr bgcolor=\"#eeeeee\"><td colspan=\"2\">"+rs.getString("contents")+"</td></tr>"+
		  "</table><hr>");
 
	if (kokku>5){
	 output.println("<form action=\"uudisteKom\" method=\"get\">"+
		"<input type=\"hidden\" name=\"id\" value=\""+id+"\">"+
		"Nitan <select name=\"limit\">"+
		"<option value=\"5\" "+(msg_per_page==5?" selected=true ":"")+">5</option>"+
		"<option value=\"10\" "+(msg_per_page==10?" selected=true ":"")+">10</option>"+
		"<option value=\"15\" "+(msg_per_page==15?" selected=true ":"")+">15</option>"+
		"<option value=\"20\" "+(msg_per_page==20?" selected=true ":"")+">20</option>"+
		"<option value=\"30\" "+(msg_per_page==30?" selected=true ":"")+">30</option>"+
		"<option value=\"50\" "+(msg_per_page==50?" selected=true ":"")+">50</option>"+
		"</select> kaupa. <input type=\"submit\" value=\"Tee seda\"></form>");
	}

	if (kokku>msg_per_page){
		output.println("| ");
	 	for(int i=0; i<kokku; i+=msg_per_page){
			if (start>=i && start<i+msg_per_page){
				output.println(""+(i+1)+"-"+(((i+msg_per_page)<kokku?(i+msg_per_page):kokku))+" | ");
			}else{
				output.println("<a href=\"uudisteKom?start="+i+"&limit="+msg_per_page+"&id="+id+"\">"+(i+1)+"-"+(((i+msg_per_page)<kokku?(i+msg_per_page):kokku))+"</a> | ");
			}
		}	 
	}	

   	 ps=connection.prepareStatement("select * from comments where msgid=? order by comid desc limit ?, ? ");
	 ps.setInt(1, id);
   	 ps.setInt(2, start);
	 ps.setInt(3, msg_per_page);
	 rs=ps.executeQuery();

	  while(rs.next()){
			aeg=rs.getDate("comtime");
			if (aeg!=null){
				strAeg=df.format(aeg);
			} else{
				strAeg=" (aeg puudub)";
			}

        output.println("<table width=\"600\"><tr><td>"+rs.getString("comauthor")+" @ "+strAeg+"</td><td align=\"right\">"+
		  (logitud?("<a href=\"kustutaja?msgid="+id+"&comment&id="+rs.getInt("comid")+"\">Kustuta</a>"):"&nbsp")+"</td></tr>"+
          "<tr bgcolor=\"#eeeeee\"><td colspan=\"2\">"+rs.getString("comcontents")+"</td></tr>"+
		 "</table><br>");
        }

	output.println("<form action=\"komLisamine\" method=\"get\">"+
		"<input type=\"hidden\" name=\"msgid\" value=\""+id+"\">"+	
		"<table width=\"600\"><tr><th>Nimi: </th><td><input type=\"text\" name=\"author\"></td></tr><th>Kommentaar: </th>"+
		"<td><textarea name=\"contents\" rows=\"10\" cols=\"60\"></textarea></td><tr></tr>"+
		"<tr><td>&nbsp;</td><td><input type=\"reset\" value=\"Thjenda\"><input type=\"submit\" value=\"Saada\"></td><tr></table></form>");

    connection.close();
	}catch(Exception e ){
		output.println("<h1>VIGA</h1>"+e.getMessage());
	}
	output.println(FOOTER);
   }
}