import javax.microedition.midlet.*;
import javax.microedition.rms.*;
import javax.microedition.lcdui.*;
import javax.microedition.io.*;
import java.io.*;
import java.util.*;



public class Veeb5 extends MIDlet{
  String hoidlanimi="hoidla2";
  TextBox t1;
  RecordStore rs;
  RecordEnumeration re;
  ValikuVorm valik;
  static MIDlet ise;
  
  
  public Veeb5(){
      try{
     	rs=RecordStore.openRecordStore(hoidlanimi, true);
     	re=rs.enumerateRecords(null, null, true);
     	ise=this;
    }catch(Exception e){teade(e.getMessage());}
  }// public Veeb5 lopp
  
  
  
  static MIDlet kysiEksemplar(){
     return ise;
  }
  
  
  protected void startApp() throws MIDletStateChangeException{
    valik=new ValikuVorm();
    Display.getDisplay(this).setCurrent(valik);
  }
  
  protected void pauseApp(){}
  protected void destroyApp(boolean kohustus) throws MIDletStateChangeException{
    try{
      rs.closeRecordStore();
    } catch (Exception e){teade(e.getMessage());} 
  }
  
 
  
  
  void teade(String teade){
    Alert a=new Alert("Teade", teade, null, AlertType.CONFIRMATION);
    a.setTimeout(5);
    Display.getDisplay(this).setCurrent(a);
  }
  
  
  
  class ValikuVorm extends List implements CommandListener{
     LisamisVorm lisamine=new LisamisVorm(this);
     VaatamisVorm vaatamine=new VaatamisVorm(this);
     Command ava=new Command("Ava", Command.SCREEN, 1);
     Command valju=new Command("Vlju", Command.EXIT, 1);
     ValikuVorm(){
       super("Tegevuse valik", List.IMPLICIT);
       append("Lisa", null);
       append("Vaata", null);
       setSelectCommand(ava);
       addCommand(valju);
       addCommand(ava);
       setCommandListener(this);
  	 }//ValikuVorm lopp
     
     
     
   public void commandAction(Command c, Displayable d){
       if(c==valju){
          notifyDestroyed();
       }
       
       if(c==ava){
         if(getSelectedIndex()==0){
           Display.getDisplay(Veeb5.this).setCurrent(lisamine);
         }
         if(getSelectedIndex()==1){
           Display.getDisplay(Veeb5.this).setCurrent(vaatamine);
         }
       }
   }//CommandAction lopp
   
   
  
  class LisamisVorm extends Form implements CommandListener, Runnable{
  	String enimeke2, pnimeke2, paevake2, kuuke2, aastake2, maakonnake2, linnake2, tanavake2, majake2, korterike2;
    TextField enimi2=new TextField("Eesnimi", "", 20, TextField.ANY);
    TextField pnimi2=new TextField("Perenimi", "", 20, TextField.ANY);
    TextField paev2=new TextField("Pev", "", 20, TextField.ANY);
    TextField kuu2=new TextField("Kuu", "", 20, TextField.ANY);
    TextField aasta2=new TextField("Aasta", "", 20, TextField.ANY);
    TextField maakond2=new TextField("Maakond", "", 20, TextField.ANY);
    TextField linn2=new TextField("Linn", "", 20, TextField.ANY);
    TextField tanav2=new TextField("Tnav", "", 20, TextField.ANY);
    TextField maja2=new TextField("Maja", "", 20, TextField.ANY);
    TextField korter2=new TextField("Korter", "", 20, TextField.ANY);
    Command lisa=new Command("Lisa", Command.SCREEN, 1);
    Command yles=new Command("les", Command.EXIT, 1);
    Displayable avaja;
    LisamisVorm(Displayable avaja){
       super("Lisamine");
       this.avaja=avaja;
       append(enimi2);
       append(pnimi2);
       append(paev2);
       append(kuu2);
       append(aasta2);
       append(maakond2);
       append(linn2);
       append(tanav2);
       append(maja2);
       append(korter2);
       addCommand(lisa);
       addCommand(yles);
       setCommandListener(this);
   	   }//LisamisVorm lopp
   
  		
  		
  	

   public void run(){ 	
    try{
        enimeke2=enimi2.getString();
        pnimeke2=pnimi2.getString();
        paevake2=paev2.getString();
        kuuke2=kuu2.getString();
        aastake2=aasta2.getString();
        maakonnake2=maakond2.getString();
        linnake2=linn2.getString();
        tanavake2=tanav2.getString();
        majake2=maja2.getString();
        korterike2=korter2.getString();
        System.out.println("LisaEesnimi:"+enimeke2);
    	System.out.println("LisaPerenimi:"+pnimeke2);
    	System.out.println(paevake2+" "+kuuke2+" "+aastake2);
    	String aadress="http://localhost:8080/examples/servlet/andmed4?eesnimi="+enimeke2+"&perenimi="+pnimeke2+"&paev="+paevake2+"&kuu="+kuuke2+"&aasta="+aastake2+"&maakond="+maakonnake2+"&linn="+linnake2+"&tanav="+tanavake2+"&maja="+majake2+"&korter="+korterike2+"&lisamine";
        InputStream sisse=Connector.openInputStream(aadress);    
    
   	}catch(Exception e){
     e.printStackTrace();
  	}
    Display.getDisplay(Veeb5.this).setCurrent(avaja);
    }
    
    
    
    	public void commandAction(Command c, Displayable d){
      		if(c==yles){
        	Display.getDisplay(Veeb5.this).setCurrent(avaja);
      		}
      		
      		if(c==lisa){
        	new Thread(this).start();
        	}
        	
   	   }//commandAction lopp
    	
    
   }//LisamisVorm extends lopp





  class VaatamisVorm extends Form implements CommandListener, Runnable{
    String eesnimeke1, perenimeke1;
    TextBox t1;
    TextField enimi=new TextField("Eesnimi", "", 20, TextField.ANY);
    TextField pnimi=new TextField("Perenimi", "", 20, TextField.ANY);
    Command edasi=new Command("Edasi", Command.SCREEN, 1);
    //Command tagasi=new Command("Tagasi", Command.SCREEN, 1);
    Command yles=new Command("les", Command.BACK, 1);
    Displayable avaja;
    VaatamisVorm(Displayable avaja){
       super("Vaatamine");
       this.avaja=avaja;
       append(enimi);
       append(pnimi);
       addCommand(edasi);
       addCommand(yles);
       setCommandListener(this); 	
  }//VaatamisVorm lopp
  
  
  public void run(){
   try{
    	eesnimeke1=enimi.getString();
        perenimeke1=pnimi.getString();
		System.out.println("Eesnimi2:"+eesnimeke1);
    	System.out.println("Perenimi2:"+perenimeke1);
    	String aadress="http://localhost:8080/examples/servlet/MituTabelit9?eesnimi="+eesnimeke1+"&perenimi="+perenimeke1+"&otsimine";
    	InputStream sisse=Connector.openInputStream(aadress);
    	ByteArrayOutputStream baos=new ByteArrayOutputStream();
    	int arv=sisse.read();
    		while(arv!=-1){
      		baos.write(arv);
      		arv=sisse.read();
    		}
    	byte[] b=baos.toByteArray();   
    	String tekst=new String(b);
        t1=new TextBox("Andmed", tekst, tekst.length(), TextField.ANY);
   	}catch(Exception e){
     e.printStackTrace();
  	}
    
  Display.getDisplay(Veeb5.kysiEksemplar()).setCurrent(t1);
  }//run lopp
  
  
  
  
  public void commandAction(Command c1, Displayable d1){
     if(c1==edasi){
     	 new Thread(this).start();
     } 
     
     if(c1==yles){
     Display.getDisplay(Veeb5.this).setCurrent(avaja);
     }
     
  }//commandAction lopp

 }//VaatamisVorm extends lopp    
   
}//Valikuvorm extends lopp
}//Veeb5 extends lopp

